%define anolis_release 1
%global __os_install_post %{nil}
%global _find_debuginfo_opts -g

Name:           bpftrace
Version:        0.20.1
Release:        %{anolis_release}%{?dist}
Summary:        High-level tracing language for Linux eBPF
License:        Apache-2.0

URL:            https://github.com/iovisor/bpftrace
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
Patch1:         0001-Workaround-OpaquePointers-for-LLVM-15.patch

# Arches will be included as upstream support is added and dependencies are
# satisfied in the respective arches
ExclusiveArch:  x86_64 aarch64

BuildRequires:  gcc-c++ cmake llvm-devel clang-devel rubygem-asciidoctor llvm-googletest
BuildRequires:  bison flex elfutils-libelf-devel zlib-devel bcc-devel >= 0.19.0-1
BuildRequires:  libbpf-devel libbpf-static binutils-devel cereal-devel libdwarf-devel python3-setuptools


%description
BPFtrace is a high-level tracing language for Linux enhanced Berkeley Packet
Filter (eBPF) available in recent Linux kernels (4.x). BPFtrace uses LLVM as a
backend to compile scripts to BPF-bytecode and makes use of BCC for
interacting with the Linux BPF system, as well as existing Linux tracing
capabilities: kernel dynamic tracing (kprobes), user-level dynamic tracing
(uprobes), and tracepoints. The BPFtrace language is inspired by awk and C,
and predecessor tracers such as DTrace and SystemTap

%package doc
Summary:    Documentation files for %{name}
Requires:   %{name} = %{version}-%{release}
BuildArch:  noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}

%prep
%autosetup -p1


%build
%cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DBUILD_TESTING:BOOL=OFF \
       -DBUILD_SHARED_LIBS:BOOL=OFF \
       -DUSE_SYSTEM_BPF_BCC:BOOL=ON
%cmake_build


%install
%cmake_install

find %{buildroot}%{_datadir}/%{name}/tools -type f -exec \
  sed -i -e '1s=^#!/usr/bin/env %{name}\([0-9.]\+\)\?$=#!%{_bindir}/%{name}=' {} \;

%generate_compatibility_deps

%files
%doc docs/reference_guide.md docs/tutorial_one_liners.md
%license LICENSE
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/tools
%dir %{_datadir}/%{name}/tools/doc
%dir %{_datadir}/%{name}/tools/old
%{_bindir}/%{name}
%{_bindir}/%{name}-aotrt
%{_mandir}/man8/*
%attr(0755,-,-) %{_datadir}/%{name}/tools/*.bt
%attr(0755,-,-) %{_datadir}/%{name}/tools/old/*.bt
%{_datadir}/%{name}/tools/doc/*.txt

%dir %{abidir}
%{abidir}/bpftrace-aotrt-option.list
%{abidir}/bpftrace-option.list

%files doc
%doc README.md CONTRIBUTING-TOOLS.md

%changelog
* Thu Mar 21 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.20.1-1
- update to 0.20.1

* Fri Apr 14 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> -  0.16.0-3
- Refactor the specfile
- cmake: Raise max llvm major version to 16

* Wed Feb 15 2023 Funda Wang <fundawang@yeah.net> - 0.16.0-2
- Rebuild for llvm 15

* Fri Oct 21 2022 Xuchun Shang <xuchun.shang@alibaba-inc.com> - 0.16.0-1
- Update to version 0.16.0

* Thu May 05 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.14.1-1
- Init from upstream  version 0.14.1
